//+------------------------------------------------------------------+ 
//|                                          Check_TerminalPaths.mq5 | 
//|                        Copyright 2009, MetaQuotes Software Corp. | 
//|                                             https://www.mql5.com | 
//+------------------------------------------------------------------+ 
#property copyright "2009, MetaQuotes Software Corp." 
#property link      "https://www.mql5.com" 
#property version   "1.00" 
//+------------------------------------------------------------------+
//| base array containing indexing, searching, sorting generic methods
//+------------------------------------------------------------------+
template<typename T>
class C1dArray
  {
protected:
   T                 m_array[];
  };
//+------------------------------------------------------------------+
//| numeric (int,double) extension to 1darray containing mathematical methods
//+------------------------------------------------------------------+
template<typename T>
class C1dNumArray:public C1dArray<T>
  {
public:
   // some mathematical methods
   T sum() { return 0; }
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class C1dStrArray:public C1dArray<string>
  {
public:
   // some string methods
  };
//+------------------------------------------------------------------+
//| Jagged 2d array containing rows of 1d array
//| basic methods like sorting,searching,indexing
//+------------------------------------------------------------------+
template<typename CT>
class C2dArray
  {
protected:
   <CT>m_rows[];
  };
//+------------------------------------------------------------------+
//| numeric extension to 2d array with mathematical methods
//+------------------------------------------------------------------+
template<typename T>
class C2dNumArray:public C2dArray<C1dArray<T>>
  {
   // some mathematical methods
public:
   T sum()
     {
      T s=0;
      for(int i=0;i<ArraySize(m_rows);i++) s+=m_rows[i].sum();
      return s;
     }
  };
//+------------------------------------------------------------------+
//| string extension to 2d array with string methods
//+------------------------------------------------------------------+
class C2dStrArray:public C2dArray<C1dArray<string>>
  {
   // some string methods
public:
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnStart()
  {
   C2dNumArray<double>a;
  }
//+------------------------------------------------------------------+
